{% extends 'store/main.html' %}
{% load static %}
{% block content %}
<div class="row">
    <div class="col-lg-6">
        <div class="box-element" id="form-wrapper">
            <form id="form">
                {% csrf_token %}
                <div id="user-info">
                    <div class="form-field">
                        <input required class="form-control" type="text" name="name" placeholder="Name..">
                    </div>
                    <div class="form-field">
                        <input required class="form-control" type="email" name="email" placeholder="Email..">
                    </div>
                </div>

                <div id="shipping-info">
                    <hr>
                    <p>Shipping Information:</p>
                    <hr>
                    <div class="form-field">
                        <input class="form-control" type="text" name="address" placeholder="Address..">
                    </div>
                    <div class="form-field">
                        <input class="form-control" type="text" name="city" placeholder="City..">
                    </div>
                    <div class="form-field">
                        <input class="form-control" type="text" name="state" placeholder="State..">
                    </div>
                    <div class="form-field">
                        <input class="form-control" type="text" name="zipcode" placeholder="Zip code..">
                    </div>
                    <div class="form-field">
                        <input class="form-control" type="text" name="country" placeholder="Zip code..">
                    </div>
                </div>

                <hr>
                <input id="form-button" class="btn btn-success btn-block" type="submit" value="Continue">
            </form>
        </div>

        <br>
        <div class="box-element hidden" id="payment-info">
            <small>Paypal Options</small>
            <!-- Set up a container element for the button -->
            <div id="paypal-button-container"></div>
<!--            <button id="make-payment">Make Payment</button>-->
        </div>

    </div>

    <div class="col-lg-6">
        <div class="box-element">
            <a  class="btn btn-outline-dark" href="{% url 'cart' %}">&#x2190; Back to Cart</a>
            <hr>
            <h3>Order Summary</h3>
            <hr>
            {% for item in items %}
            <div class="cart-row">
                <div style="flex:2"><img class="row-image" src="{{item.product.imageURL}}"></div>
                <div style="flex:2"><p>{{item.product.name}}</p></div>
                <div style="flex:1"><p>{{item.product.price|floatformat:2}}</p></div>
                <div style="flex:1"><p>{{item.quantity}}</p></div>
            </div>
            {% endfor %}
            <h5>Items:   {{order.get_car_items}}</h5>
            <h5>Total:   {{order.get_cart_total|floatformat:2}}</h5>
        </div>
    </div>
</div>

<!-- Include the PayPal JavaScript SDK -->
<script src="https://www.paypal.com/sdk/js?client-id=AZwiQERNd9brKXUqojmbLXZ-kMxaNGi6ei-8baRCfMjrcJEjWhGXcvmKk6NVJZMKLLHGFM_7GNuV7ICr&currency=USD&disable-funding=credit"></script>

<script>
    var total = '{{order.get_cart_total}}'

    // Render the PayPal button into #paypal-button-container
    paypal.Buttons({

        style:{
            color:'blue',
            shape:'rect',
        },

        // Set up the transaction
        createOrder: function(data, actions) {
            return actions.order.create({
                purchase_units: [{
                    amount: {
                        value: parseFloat(total).toFixed(2)
                    }
                }]
            });
        },

        // Finalize the transaction
        onApprove: function(data, actions) {
            return actions.order.capture().then(function(orderData) {
                // Successful capture! For demo purposes:
                console.log('Capture result', orderData, JSON.stringify(orderData, null, 2));
                // var transaction = orderData.purchase_units[0].payments.captures[0];
                // alert('Transaction '+ transaction.status + ': ' + transaction.id + '\n\nSee console for all available details');

                //send order info to backend
                sumbitFormData()

                // Replace the above to show a success message within this page, e.g.
                // const element = document.getElementById('paypal-button-container');
                // element.innerHTML = '';
                // element.innerHTML = '<h3>Thank you for your payment!</h3>';
                // Or go to another URL:  actions.redirect('thank_you.html');
            });
        }


    }).render('#paypal-button-container');
</script>

<script type="text/javascript">
    var shipping = '{{order.shipping}}'
    var total = '{{order.get_cart_total}}'


    // checking for digital products if so dont show shipping form, 'shipping': False
    if(shipping == 'False'){
        document.getElementById('shipping-info').innerHTML = ''
    }
    //hide name form if user is already authenticated
    if (user != 'AnonymousUser'){
        document.getElementById('user-info').innerHTML = ''
    }

    if (shipping == 'False' && user != 'AnonymousUser'){
        document.getElementById('form-wrapper').classList.add("hidden");
        //show payment if logged in user wants to buy an item that doesnt need shipping
        document.getElementById('payment-info').classList.remove("hidden");
    }

    //once shipping info has been added remove button add payment section
    var form = document.getElementById('form')

    csrftoken = form.getElementsByTagName("input")[0].value

    form.addEventListener('submit', function (e){
        e.preventDefault()
        console.log('Form Submitted..')
        document.getElementById('form-button').classList.add("hidden");
        document.getElementById('payment-info').classList.remove("hidden");
    })

    //Event handler for payment form
    // document.getElementById('make-payment').addEventListener('click', function (e){
    //     sumbitFormData()
    // })

    function sumbitFormData(){
        console.log('Clucked')

        var userFormData = {
            'name':null,
            'email':null,
            'total':total,
        }
        var shippingInfo = {
            'address':null,
            'city':null,
            'state':null,
            'zipcode':null,
        }

        if (shipping != 'False'){
            shippingInfo.address = form.address.value
            shippingInfo.city = form.city.value
            shippingInfo.state = form.state.value
            shippingInfo.zipcode = form.zipcode.value
        }

        if (user == 'AnonymousUser'){
            userFormData.name = form.name.value
            userFormData.email = form.email.value
        }
        //Post form data to the url handling receiving the payment info
        var url = "/process_order/"
        fetch(url, {
            method:'POST',
            headers:{
                'Content-Type':'application/json',
                'X-CSRFToken': csrftoken,
            },
            body:JSON.stringify({'form':userFormData, 'shipping':shippingInfo}),
        })
        .then((response) => response.json())
        .then((data) => {
            console.log('Success: ', data);
            alert('Transaction completed');
            cart = {}
            document.cookie = 'cart=' + JSON.stringify(cart) + ";domain=;path=/"
            window.location.href = "{% url 'store' %}"
        })
    }

</script>
{% endblock content %}